/* #define XPRDEBUG 1 */
#include <terminal/terminal.h>

void main()
{
	OpenAll();
	LoopEm();
	CleanExit();
}

void go_away(UWORD return_code)
{
	if(ReqBase)
		CloseLibrary((struct Library *)ReqBase);
	if(timermsg)
		DeleteExtIO((struct IORequest *)timermsg);
	if(TimerPort)
		DeletePort(TimerPort);
	if(ConsoleIn)
		DeleteExtIO(ConsoleIn);
	if(ConsoleReadPort)
		DeletePort(ConsoleReadPort);
	if(ConsoleWritePort)
		DeletePort(ConsoleWritePort);
	if(SerialReadPort)
		DeletePort(SerialReadPort);
	if(SerialWritePort)
		DeletePort(SerialWritePort);
	if(BackWindow)
		CloseWindow(BackWindow);
	if(Scr)
		CloseScreen(Scr);
	exit(FALSE);
}

void PrefIt()
{
	struct Preferences prefs;
	char read, write, stop, parity, hs;

	GetPrefs(&prefs,sizeof(struct Preferences));
	
	read = (char)(prefs.SerRWBits)&SREAD_BITS;
	read = 8-(read >> 4);
	write = (char)(prefs.SerRWBits)&SWRITE_BITS;
	write = 8-write;
	SerialIn->io_ReadLen = read;
	SerialOut->io_WriteLen = write;
	stop = (char)(prefs.SerStopBuf)&SSTOP_BITS;
	stop = (stop >> 4)+1;
	SerialIn->io_StopBits = stop;
	SerialOut->io_StopBits = stop;
	parity = (char)SPARNUM(prefs.SerParShk);
	hs = (char)SHAKNUM(prefs.SerParShk);
	switch(parity)
	{
		case SPARITY_NONE:	SerialIn->io_SerFlags &= ~SERF_PARTY_ON;
									SerialOut->io_SerFlags &= ~SERF_PARTY_ON;
									break;
		case SPARITY_EVEN:	SerialIn->io_SerFlags |= SERF_PARTY_ON;
									SerialOut->io_SerFlags |= SERF_PARTY_ON;
									SerialIn->io_SerFlags &= ~SERF_PARTY_ODD;
									SerialOut->io_SerFlags &= ~SERF_PARTY_ODD;
									break;
		case SPARITY_ODD:		SerialIn->io_SerFlags |= SERF_PARTY_ON;
									SerialOut->io_SerFlags |= SERF_PARTY_ON;
									SerialIn->io_SerFlags |= SERF_PARTY_ODD;
									SerialOut->io_SerFlags |= SERF_PARTY_ODD;
									break;
		case 3:					SerialIn->io_SerFlags |= SERF_PARTY_ON;
									SerialOut->io_SerFlags |= SERF_PARTY_ON;
									SerialIn->io_ExtFlags |= SEXTF_MSPON;
									SerialOut->io_ExtFlags |= SEXTF_MSPON;
									SerialIn->io_ExtFlags |= SEXTF_MARK;
									SerialOut->io_ExtFlags |= SEXTF_MARK;
									break;
		case 4:					SerialIn->io_SerFlags |= SERF_PARTY_ON;
									SerialOut->io_SerFlags |= SERF_PARTY_ON;
									SerialIn->io_ExtFlags |= SEXTF_MSPON;
									SerialOut->io_ExtFlags |= SEXTF_MSPON;
									SerialIn->io_ExtFlags &= ~SEXTF_MARK;
									SerialOut->io_ExtFlags &= ~SEXTF_MARK;
									break;
	}
	SerialIn->IOSer.io_Command = SDCMD_SETPARAMS;
	SerialOut->IOSer.io_Command = SDCMD_SETPARAMS;
	DoIO((struct IORequest *)SerialOut);
	DoIO((struct IORequest *)SerialIn);
}

void OpenAll()
{
	int error;
	struct Preferences prefs;
	char version[81];

	strcpy(version,"$VER: My_Dumb_Terminal 1.00 (22.7.91)");
	ReqBase = (struct ReqLib *)OpenLibrary("req.library",0);
	if(!ReqBase)
	{
		printf("req.library wouldn't open.\n");
		go_away(20);
	}
	// This part causes AmigaDOS (and Intuition) to open all requestors
	// on our screen (window) while we're open.  MUST MUST be restored
	// before shutting down.  See CleanExit().  BTW, req.library observes
	// the windowptr field when opening up requestors.
	IntuitionBase = ReqBase->IntuiLib;
	GfxBase = ReqBase->GfxLib;
	MyProcess = (struct Process *)FindTask(NULL);
	Scr = OpenScreen(&NewScr);
	if (!Scr)
	{
		printf("Couldn't open screen.  Not enough memory?\n");
		go_away(20);
	}

	NewWin.Screen = Scr;
	BackWindow = OpenWindow(&NewWin);
	if (!BackWindow)
	{
		printf("Couldn't open Window!  Not enough memory?\n");
		go_away(20);
	}

	// Cache the original window pointer to restore later
	OldWindowPointer = (struct Window *)MyProcess->pr_WindowPtr;
	MyProcess->pr_WindowPtr = (APTR)BackWindow;

	SerialReadPort = CreatePort(0,0);
	if(!SerialReadPort)
	{
		printf("Error opening MsgPort\n");
		go_away(20);
	}
	SerialWritePort = CreatePort(0,0);
	if(!SerialWritePort)
	{
		printf("Error opening MsgPort\n");
		go_away(20);
	}
	ConsoleReadPort = CreatePort(0,0);
	if(!ConsoleReadPort)
	{
		printf("Error opening MsgPort\n");
		go_away(20);
	}
	ConsoleWritePort = CreatePort(0,0);
	if(!ConsoleWritePort)
	{
		printf("Error opening MsgPort\n");
		go_away(20);
	}
	TimerPort = CreatePort(0,0);
	if(!TimerPort)
	{
		printf("Error opening MsgPort\n");
		go_away(20);
	}
	ConsoleIn = (struct IOStdReq *)CreateExtIO(ConsoleReadPort,sizeof(struct IOStdReq));
	if(!ConsoleIn)
	{
		printf("Error creating StdIO\n");
		go_away(20);
	}
	ConsoleOut = (struct IOStdReq *)CreateExtIO(ConsoleWritePort,sizeof(struct IOStdReq));
	if(!ConsoleOut)
	{
		printf("Error creating StdIO\n");
		go_away(20);
	}
	ConsoleIn->io_Data = (APTR)BackWindow;
	ConsoleIn->io_Length = sizeof(struct Window);
	error = OpenDevice("console.device",0,ConsoleIn,0);
	if(error)
	{
		printf("Error opening console.device");
		go_away(20);
	}
	ConsoleOut->io_Device = ConsoleIn->io_Device;
	ConsoleOut->io_Unit = ConsoleIn->io_Unit;

	SerialIn = (struct IOExtSer *)CreateExtIO(SerialReadPort,sizeof(struct IOExtSer));
	if(!SerialIn)
	{
		printf("Unable to allocate enough memory.\n");
		go_away(20);
	}
	SerialOut = (struct IOExtSer *)CreateExtIO(SerialWritePort,sizeof(struct IOExtSer));
	if(!SerialOut)
	{
		printf("Unable to allocate enough memory.\n");
		go_away(20);
	}
	error = OpenDevice("serial.device",0,(struct IOStdReq *)SerialIn,0);
	if(error)
	{
		printf("Error opening serial.device\n");
		go_away(20);
	}
	SerialOut->IOSer.io_Device = SerialIn->IOSer.io_Device;
	SerialOut->IOSer.io_Unit = SerialIn->IOSer.io_Unit;
	xpr_setserial(xpr_setserial(-1)); // copy all the serial port settings into SerialOut
	PrefIt();
	GetPrefs(&prefs,sizeof(struct Preferences));
	switch(prefs.BaudRate)
	{
		case BAUD_110:		SerialOut->io_Baud = 110;
								SerialIn->io_Baud = 110;
								break;
		case BAUD_300:		SerialOut->io_Baud = 300;
								SerialIn->io_Baud = 300;
								break;
		case BAUD_1200:	SerialOut->io_Baud = 1200;
								SerialIn->io_Baud = 1200;
								break;
		case BAUD_2400:	SerialOut->io_Baud = 2400;
								SerialIn->io_Baud = 2400;
								break;
		case BAUD_4800:	SerialOut->io_Baud = 4800;
								SerialIn->io_Baud = 4800;
								break;
		case BAUD_9600:	SerialOut->io_Baud = 9600;
								SerialIn->io_Baud = 9600;
								break;
		case BAUD_19200:	SerialOut->io_Baud = 19200;
								SerialIn->io_Baud = 19200;
								break;
	}
	SerialIn->IOSer.io_Command = SDCMD_SETPARAMS;
	SerialOut->IOSer.io_Command = SDCMD_SETPARAMS;
	DoIO((struct IORequest *)SerialOut);
	DoIO((struct IORequest *)SerialIn);

	SetRGB4(&Scr->ViewPort,0,0,0,0);		/* BLACK */
	SetRGB4(&Scr->ViewPort,1,15,0,0);		/* RED */
	SetRGB4(&Scr->ViewPort,2,0,15,0);		/* GREEN */
	SetRGB4(&Scr->ViewPort,3,15,15,0);		/* YELLOW */
	SetRGB4(&Scr->ViewPort,4,0,0,15);		/* BLUE */
	SetRGB4(&Scr->ViewPort,5,15,0,15);		/* PURPLE */
	SetRGB4(&Scr->ViewPort,6,0,15,15);		/* CYAN */
	SetRGB4(&Scr->ViewPort,7,15,15,15);		/* WHITE */

	SetMenuStrip(BackWindow,&Menu1);

	timermsg = (struct timerequest *)CreateExtIO(TimerPort,sizeof(struct timerequest));
	if(!timermsg)
	{
		printf("Out of memory.\n");
		go_away(20);
	}
	timermsg->tr_node.io_Message.mn_ReplyPort = TimerPort;
	timermsg->tr_node.io_Message.mn_Node.ln_Type = NT_MESSAGE;
	error = OpenDevice("timer.device",UNIT_VBLANK,(struct IORequest *)timermsg,0);
	if(error)
	{
		printf("Error opening timer.device.\n");
		go_away(20);
	}
}

void CleanExit()
{
	ClearMenuStrip(BackWindow);
	CloseDevice((struct IORequest *)SerialIn);
	DeleteExtIO((struct IORequest *)SerialIn);
	DeleteExtIO((struct IORequest *)SerialOut);
	while(GetMsg(SerialReadPort));
	DeletePort(SerialReadPort);
	while(GetMsg(SerialWritePort));
	DeletePort(SerialWritePort);
	CloseDevice(ConsoleIn);
	DeleteExtIO(ConsoleIn);
	DeleteExtIO(ConsoleOut);
	while(GetMsg(ConsoleReadPort));
	DeletePort(ConsoleReadPort);
	while(GetMsg(ConsoleWritePort));
	DeletePort(ConsoleWritePort);
	CloseWindow(BackWindow);
	CloseScreen(Scr);
	CloseLibrary((struct Library *)ReqBase);
	// restore the original window pointer for requestors
	MyProcess->pr_WindowPtr = (APTR)OldWindowPointer;
	CloseDevice((struct IORequest *)timermsg);
	DeleteExtIO((struct IORequest *)timermsg);
	while(GetMsg(TimerPort));
	DeletePort(TimerPort);
}

void QueueSerial(char *buffer, long size)
{
	SerialIn->IOSer.io_Command = CMD_READ;
	SerialIn->IOSer.io_Data = (APTR)buffer;
	SerialIn->IOSer.io_Length = size;
	SendIO((struct IORequest *)SerialIn);
}

void QueueConsole(char *buffer, long size)
{
	ConsoleIn->io_Command = CMD_READ;
	ConsoleIn->io_Data = (APTR)buffer;
	ConsoleIn->io_Length = size;
	SendIO(ConsoleIn);
}

void ModemOut(char *buffer, int length)
{
	SerialOut->IOSer.io_Length = length;
	SerialOut->IOSer.io_Data = (APTR)buffer;
	SerialOut->IOSer.io_Command = CMD_WRITE;
	DoIO((struct IORequest *)SerialOut);
}

void ScreenOut(char *buffer, int length)
{
	ConsoleOut->io_Length = length;
	ConsoleOut->io_Data = (APTR)buffer;
	ConsoleOut->io_Command = CMD_WRITE;
	DoIO(ConsoleOut);
}

void LoopEm()
{
	struct GetLongStruct gls;
	long signals, mask;
	long CharsAvail;
	char SerInBuf[81];
	char ConInBuf[81];
	long code, class;

	mask = (1L << ConsoleReadPort->mp_SigBit)|
		(1L << BackWindow->UserPort->mp_SigBit)|
		(1L << SerialReadPort->mp_SigBit);

	while(1) // forever
	{
		QueueSerial(SerInBuf,1);
		QueueConsole(ConInBuf,1);
		signals = Wait(mask);
		if(signals & (1L << ConsoleReadPort->mp_SigBit))
			ModemOut(ConInBuf,1);
		else
		{
			AbortIO(ConsoleIn);
			Wait(1L << ConsoleReadPort->mp_SigBit);
		}
		GetMsg(ConsoleReadPort);
		if(signals & (1L << SerialReadPort->mp_SigBit))
		{
			GetMsg(SerialReadPort);
			ScreenOut(SerInBuf,1);
			SerialIn->IOSer.io_Command = SDCMD_QUERY;
			DoIO((struct IORequest *)SerialIn);
			CharsAvail = SerialIn->IOSer.io_Actual;
			if(CharsAvail)
			{
				if(CharsAvail > 80)
					CharsAvail = 80;
				SerialIn->IOSer.io_Data = (APTR)SerInBuf;
				SerialIn->IOSer.io_Command = CMD_READ;
				SerialIn->IOSer.io_Length = CharsAvail;
				DoIO((struct IORequest *)SerialIn);
				ScreenOut(SerInBuf,CharsAvail);
			}
		}
		else
		{
			AbortIO((struct IORequest *)SerialIn);
			Wait(1L << SerialReadPort->mp_SigBit);
			GetMsg(SerialReadPort);
		}
		if(signals & (1L << BackWindow->UserPort->mp_SigBit))
		{
			IntuiMsg = (struct IntuiMessage *)GetMsg(BackWindow->UserPort);
			class = IntuiMsg->Class;
			code = IntuiMsg->Code;
			ReplyMsg((struct Message *)IntuiMsg);
			if(class == NEWPREFS)
				PrefIt();
			if(class != MENUPICK)
				continue;
			if(MENUNUM(code) != 0)
				continue;
			switch(ITEMNUM(code))
			{
				case 0:	SimpleRequest("     My Dumb Terminal v1.00 by Ken Schenke\n\n   Donated to Public Domain on "__DATE__".\n\n May only be distributed in unmodified form in\n original archive.  Please see documentation\n for more information.\n\n(C) 1991 ParaLogic Software International, Inc.");
							break;
				case 1:	SerialIn->IOSer.io_Command = SDCMD_SETPARAMS;
							DoIO((struct IORequest *)SerialIn);
							gls.titlebar = "New Baud Rate";
							gls.defaultval = (long)SerialIn->io_Baud;
							gls.minlimit = 0L;
							gls.maxlimit = 115200L; // seems high enough for now
							gls.versionnumber = 0L;
							gls.rfu2 = 0L;
							gls.window = NULL;
							if(GetLong(&gls))
							{
								SerialIn->io_Baud = gls.result;
								SerialIn->IOSer.io_Command = SDCMD_SETPARAMS;
								DoIO((struct IORequest *)SerialIn);
								SerialOut->io_Baud = gls.result;
								SerialOut->IOSer.io_Command = SDCMD_SETPARAMS;
								DoIO((struct IORequest *)SerialOut);
							}
							break;
				case 2:	Upload();
							break;
				case 3:	Download();
							break;
				case 4:	return;
			}
		}
	}
}

BOOL GetProtocol(char *name)
{
	struct FileRequester *MyFileReq;
	char DirStr[FCHARS+1];
	BOOL result = FALSE;

	name[0] = '\0';
	MyFileReq = (struct FileRequester *)AllocMem(sizeof(struct FileRequester),MEMF_PUBLIC|MEMF_CLEAR);
	if(!MyFileReq)
		return FALSE;
	strcpy(DirStr,"LIBS:");
	strcpy(MyFileReq->Show,"xpr*");
	MyFileReq->VersionNumber = 0;
	MyFileReq->Title = "Select a Protocol";
	MyFileReq->Dir = DirStr;
	MyFileReq->File = name;
	MyFileReq->PathName = NULL;
	MyFileReq->Window = NULL;
	MyFileReq->numlines = 20;
	MyFileReq->numcolumns = 40;
	MyFileReq->devcolumns = 10;
	MyFileReq->Flags = NULL;
	MyFileReq->MaxExtendedSelect = 0;
	MyFileReq->detailcolor = 4;
	MyFileReq->blockcolor = 7;
	MyFileReq->dirnamescolor = 3;
	MyFileReq->filenamescolor = 7;
	MyFileReq->devicenamescolor = 6;
	MyFileReq->gadgettextcolor = 7;
	MyFileReq->textmessagecolor = 7;
	MyFileReq->stringnamecolor = 7;
	MyFileReq->stringgadgetcolor = 3;
	MyFileReq->boxbordercolor = 3;
	MyFileReq->gadgetboxcolor = 3;
	if(FileRequester(MyFileReq))
		result = TRUE;
	FreeMem(MyFileReq,sizeof(struct FileRequester));
}

void Upload()
{
	char DirStr[DSIZE+1], temp[81], node[81], name[81], path[DSIZE+FCHARS+2],
		file[FCHARS+1];

	xpr_setup(&io);
	if(!GetProtocol(name))
		return;
	XProtocolBase = OpenLibrary(name,0L);
	if(!XProtocolBase)
	{
		SimpleRequest("Error opening protocol: \"%s\"",name);
		return;
	}
	strsfn(name,temp,temp,node,temp);
	io.xpr_filename = getenv(node);
	xpr_savea4();
	SetupReturn = XProtocolSetup(&io);
	if(!TestBit(SetupReturn,1))
	{
		SimpleRequest("Protocol Intialization failed.");
		return;
	}
	MyFileReq = (struct FileRequester *)AllocMem(sizeof(struct FileRequester),MEMF_PUBLIC|MEMF_CLEAR);
	if(!MyFileReq)
	{
		xpr_savea4();
		XProtocolCleanup(&io);
		CloseLibrary(XProtocolBase);
		return;
	}
	if(!TestBit(SetupReturn,3)) // Protocol requires no file requester
	{
		MyFileReq->VersionNumber = 0;
		MyFileReq->File = file;
		MyFileReq->PathName = path;
		MyFileReq->Dir = DirStr;
		MyFileReq->Window = NULL;
		MyFileReq->numlines = 20;
		MyFileReq->numcolumns = 40;
		MyFileReq->devcolumns = 10;
		MyFileReq->Flags = FRQEXTSELECTM;
		MyFileReq->MaxExtendedSelect = 5;
		DirStr[0] = '\0';
		MyFileReq->Title = "File(s) to Upload";
		MyFileReq->Show[0] = '\0';
		MyFileReq->detailcolor = 4;
		MyFileReq->blockcolor = 7;
		MyFileReq->dirnamescolor = 3;
		MyFileReq->filenamescolor = 7;
		MyFileReq->devicenamescolor = 6;
		MyFileReq->gadgettextcolor = 7;
		MyFileReq->textmessagecolor = 7;
		MyFileReq->stringnamecolor = 7;
		MyFileReq->stringgadgetcolor = 3;
		MyFileReq->boxbordercolor = 3;
		MyFileReq->gadgetboxcolor = 3;
		if(!FileRequester(MyFileReq))
		{
			FreeMem(MyFileReq,sizeof(struct FileRequester));
			xpr_savea4();
			XProtocolCleanup(&io);
			CloseLibrary(XProtocolBase);
			return;
		}
		io.xpr_filename = path;
	}
	else
		io.xpr_filename = NULL;
	NewXferWindow.Screen = Scr;
	NewXferWindow.Title = "Protocol Send Status";
	XferWindow = OpenWindow(&NewXferWindow);
	if(!XferWindow)
	{
		SimpleRequest("Unable to open transfer window.\n     Not enough memory?");
		FreeMem(MyFileReq,sizeof(struct FileRequester));
		xpr_savea4();
		XProtocolCleanup(&io);
		CloseLibrary(XProtocolBase);
		return;
	}
	PrintIText(XferWindow->RPort,&XferTextList,0,0); // Print the fields
	xpr_savea4();
	XProtocolSend(&io);
	Delay(100L);
	CloseWindow(XferWindow);
	XferWindow = NULL;
	xpr_savea4();
	XProtocolCleanup(&io);
	CloseLibrary((struct Library *)XProtocolBase);
	PurgeFiles(MyFileReq);
	FreeMem(MyFileReq,sizeof(struct FileRequester));
}

void Download()
{
	char DirStr[DSIZE+1], temp[81], node[81], name[81];

	xpr_setup(&io);
	if(!GetProtocol(name))
		return;
	XProtocolBase = OpenLibrary(name,0);
	if(!XProtocolBase)
	{
		SimpleRequest("Error opening protocol: \"%s\"",name);
		return;
	}
	strsfn(name,temp,temp,node,temp);
	io.xpr_filename = getenv(node);
	xpr_savea4();
	SetupReturn = XProtocolSetup(&io);
	if(!TestBit(SetupReturn,1))
	{
		SimpleRequest("Protocol initialization failed");
		CloseLibrary(XProtocolBase);
		return;
	}
	MyFileReq = (struct FileRequester *)AllocMem(sizeof(struct FileRequester),MEMF_PUBLIC|MEMF_CLEAR);
	if(!MyFileReq)
	{
		xpr_savea4();
		XProtocolCleanup(&io);
		CloseLibrary(XProtocolBase);
		return;
	}
	if(!TestBit(SetupReturn,2)) // Protocol requires no file requester
	{
		MyFileReq->VersionNumber = 0;
		MyFileReq->File = temp;
		MyFileReq->PathName = NULL;
		MyFileReq->Window = NULL;
		MyFileReq->numlines = 20;
		MyFileReq->numcolumns = 40;
		MyFileReq->devcolumns = 10;
		MyFileReq->Flags = NULL;
		MyFileReq->MaxExtendedSelect = 0;
		DirStr[0] = '\0';
		MyFileReq->Title = "File(s) to Download";
		MyFileReq->Show[0] = '\0';
		MyFileReq->detailcolor = 4;
		MyFileReq->blockcolor = 7;
		MyFileReq->dirnamescolor = 3;
		MyFileReq->filenamescolor = 7;
		MyFileReq->devicenamescolor = 6;
		MyFileReq->gadgettextcolor = 7;
		MyFileReq->textmessagecolor = 7;
		MyFileReq->stringnamecolor = 7;
		MyFileReq->stringgadgetcolor = 3;
		MyFileReq->boxbordercolor = 3;
		MyFileReq->gadgetboxcolor = 3;
		if(!FileRequester(MyFileReq))
		{
			FreeMem(MyFileReq,sizeof(struct FileRequester));
			xpr_savea4();
			XProtocolCleanup(&io);
			CloseLibrary(XProtocolBase);
			return;
		}
		io.xpr_filename = temp;
	}
	else
		io.xpr_filename = NULL;
	NewXferWindow.Screen = Scr;
	NewXferWindow.Title = "Protocol Receive Status";
	XferWindow = OpenWindow(&NewXferWindow);
	if(!XferWindow)
	{
		SimpleRequest("Unable to open transfer window.\n     Not enough memory?");
		FreeMem(MyFileReq,sizeof(struct FileRequester));
		xpr_savea4();
		XProtocolCleanup(&io);
		CloseLibrary(XProtocolBase);
		return;
	}
	PrintIText(XferWindow->RPort,&XferTextList,0,0);
	xpr_savea4();
	XProtocolReceive(&io);
	Delay(100L); // ~1 second
	CloseWindow(XferWindow);
	XferWindow = NULL;
	xpr_savea4();
	XProtocolCleanup(&io);
	CloseLibrary((struct Library *)XProtocolBase);
	FreeMem(MyFileReq,sizeof(struct FileRequester));
}

void *xpr_fopen(char *filename, char *accessmode)
{
	void *fp;
	#if XPRDEBUG
	ScreenOut("Entering xpr_fopen ",-1);
	#endif
	fp = (void *)(fopen(filename,accessmode));
	#if XPRDEBUG
	ScreenOut("Exiting xpr_fopen ",-1);
	#endif
	return fp;
}

void xpr_fclose(void *filepointer)
{
	#if XPRDEBUG
	ScreenOut("Entering xpr_fclose ",-1);
	#endif
	fclose((FILE *)filepointer);
	#if XPRDEBUG
	ScreenOut("Exiting xpr_fclose ",-1);
	#endif
}

long xpr_fread(char *buffer, long size, long count, void *fileptr)
{
	long actual;
	#if XPRDEBUG
	ScreenOut("Entering xpr_fread ",-1);
	#endif
	actual = fread(buffer,(int)size,(int)count,(FILE *)fileptr);
	#if XPRDEBUG
	ScreenOut("Exiting xpr_fread ",-1);
	#endif
	return actual;
}

long xpr_fwrite(char *buffer, long size, long count, void *fileptr)
{
	long actual;
	#if XPRDEBUG
	ScreenOut("Entering xpr_fwrite ",-1);
	#endif
	actual = fwrite(buffer,(int)size,(int)count,(FILE *)fileptr);
	#if XPRDEBUG
	ScreenOut("Exiting xpr_fwrite ",-1);
	#endif
	return actual;
}

BOOL CheckTimer()
{
	BOOL test;
	#if XPRDEBUG
	ScreenOut("Entering CheckTimer\n",-1);
	#endif
	if(CheckIO((struct IORequest *)timermsg))
		test =  FALSE;
	else
		test = TRUE;
	#if XPRDEBUG
	ScreenOut("Exiting CheckTimer\n",-1);
	#endif
	return test;
}

void SetTimer(long seconds, long micros)
{
	#if XPRDEBUG
	ScreenOut("Entering SetTimer\n",-1);
	#endif
	while(GetMsg(TimerPort)); // Clear the timerport of crud
	if(micros)
	{
		seconds = micros/1000000L;
		micros %= 1000000L;
	}
	timermsg->tr_node.io_Command = TR_ADDREQUEST;
	timermsg->tr_time.tv_secs = seconds;
	timermsg->tr_time.tv_micro = micros;
	SendIO((struct IORequest *)timermsg);
	#if XPRDEBUG
	ScreenOut("Exiting SetTimer\n",-1);
	#endif
}

void AbortTimer()
{
	#if XPRDEBUG
	ScreenOut("Entering AbortTimer\n",-1);
	#endif
	AbortIO((struct IORequest *)timermsg);
	Wait(1L << TimerPort->mp_SigBit);
	(void)GetMsg(TimerPort);
	#if XPRDEBUG
	ScreenOut("Exiting AbortTimer\n",-1);
	#endif
}

long xpr_sread(char *buffer, long size, long timeout)
{
	long signals, actual = 0L;

	#if XPRDEBUG
	ScreenOut("Entering xpr_sread ",-1);
	#endif
	/* Test for carrier before anything else
	SerialIn->IOSer.io_Command = SDCMD_QUERY;
	DoIO((struct IORequest *)SerialIn);
	if(TestBit(SerialIn->io_Status,6))
		return -1L; no carrier, exit */
	if(timeout)
	{
		QueueSerial(buffer,size);
		SetTimer(0, timeout);
		signals = Wait((1L << SerialReadPort->mp_SigBit)|(1L << TimerPort->mp_SigBit));
		if(signals & (1L << SerialReadPort->mp_SigBit))
		{
			(void)GetMsg(SerialReadPort);
			AbortTimer();
		}
		if(signals & (1L << TimerPort->mp_SigBit))
		{
			(void)GetMsg(TimerPort);
			AbortIO((struct IORequest *)SerialIn);
			Wait(1L << SerialReadPort->mp_SigBit);
			(void)GetMsg(SerialReadPort);
		}
		actual = (long)SerialIn->IOSer.io_Actual;
		if(SerialIn->IOSer.io_Error)
			actual = -1L;
	}
	else
	{
		SerialIn->IOSer.io_Command = SDCMD_QUERY;
		DoIO((struct IORequest *)SerialIn);
		if(SerialIn->IOSer.io_Actual > size)
			SerialIn->IOSer.io_Length = size;
		else
			SerialIn->IOSer.io_Length = SerialIn->IOSer.io_Actual;
		SerialIn->IOSer.io_Command = CMD_READ;
		SerialIn->IOSer.io_Data = (APTR)buffer;
		SerialIn->IOSer.io_Error = 0;
		DoIO((struct IORequest *)SerialIn);
		actual = (long)SerialIn->IOSer.io_Actual;
		if(SerialIn->IOSer.io_Error)
			actual = -1L;
	}
	#if XPRDEBUG
	ScreenOut("Exiting xpr_sread ",-1);
	#endif
	return actual;
}

long xpr_swrite(char *buffer, long size)
{
	#if XPRNODEBUG
	ScreenOut("Entering xpr_swrite ",-1);
	#endif
	/* check for carrier real quick
	SerialOut->IOSer.io_Command = SDCMD_QUERY;
	DoIO((struct IORequest *)SerialOut);
	if(TestBit(SerialOut->io_Status,6))
		return 1L; no carrier, exit */
	ModemOut(buffer,size);
	#if XPRNODEBUG
	ScreenOut("Exiting xpr_swrite ",-1);
	#endif
	return (long)SerialOut->IOSer.io_Error;
}

long xpr_sflush()
{
	#if XPRDEBUG
	ScreenOut("Entering xpr_sflush ",-1);
	#endif
	SerialOut->IOSer.io_Command = CMD_FLUSH;
	DoIO((struct IORequest *)SerialOut);
	#if XPRDEBUG
	ScreenOut("Exiting xpr_sflush ",-1);
	#endif
	return (long)SerialOut->IOSer.io_Error;
}

long xpr_update(struct XPR_UPDATE *updatestruct)
{
	struct IntuiText CurrentText;
	char temp[81], temp2[81];
	long percent;
	double tempnum;

	#if XPRDEBUG
	ScreenOut("Entering xpr_update ",-1);
	#endif
	CurrentText.DrawMode = JAM2;
	CurrentText.FrontPen = 7;
	CurrentText.BackPen = 0;
	CurrentText.NextText = NULL;
	CurrentText.ITextFont = NULL;

	if((updatestruct->xpru_updatemask)&XPRU_PROTOCOL)
	{
		sprintf(temp,"%-16s",updatestruct->xpru_protocol);
		CurrentText.TopEdge = XferText1.TopEdge;
		CurrentText.LeftEdge = XferText1.LeftEdge+IntuiTextLength(&XferText1)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	if(updatestruct->xpru_updatemask&XPRU_FILENAME)
	{
		sprintf(temp,"%-36s",updatestruct->xpru_filename);
		CurrentText.TopEdge = XferText2.TopEdge;
		CurrentText.LeftEdge = XferText2.LeftEdge+IntuiTextLength(&XferText2)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	if(updatestruct->xpru_updatemask&XPRU_BYTES)
	{
		sprintf(temp,"%-10ld",updatestruct->xpru_bytes);
		CurrentText.TopEdge = XferText3.TopEdge;
		CurrentText.LeftEdge = XferText3.LeftEdge+IntuiTextLength(&XferText3)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);

		CurrentText.TopEdge = XferText13.TopEdge;
		CurrentText.LeftEdge = XferText13.LeftEdge+IntuiTextLength(&XferText13)+8;
		if(filesize == 0L) // better safe than sorry
			percent = 0L;
		else
		{
			tempnum = (double)(updatestruct->xpru_bytes)/filesize;
			tempnum = (double)tempnum*100.0;
			percent = (long)tempnum;
		}
		sprintf(temp,"%ld%%",percent);
		sprintf(temp2,"%-5s",temp);
		CurrentText.IText = temp2;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	if(updatestruct->xpru_updatemask&XPRU_FILESIZE)
	{
		sprintf(temp,"%-12ld",updatestruct->xpru_filesize);
		CurrentText.TopEdge = XferText4.TopEdge;
		CurrentText.LeftEdge = XferText4.LeftEdge+IntuiTextLength(&XferText4)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
		filesize = updatestruct->xpru_filesize;
	}
	if(updatestruct->xpru_updatemask&XPRU_BLOCKSIZE)
	{
		sprintf(temp,"%-12ld",updatestruct->xpru_blocksize);
		CurrentText.TopEdge = XferText5.TopEdge;
		CurrentText.LeftEdge = XferText5.LeftEdge+IntuiTextLength(&XferText5)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	if(updatestruct->xpru_updatemask&XPRU_ERRORS)
	{
		sprintf(temp,"%-12ld",updatestruct->xpru_errors);
		CurrentText.TopEdge = XferText6.TopEdge;
		CurrentText.LeftEdge = XferText6.LeftEdge+IntuiTextLength(&XferText6)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	if(updatestruct->xpru_updatemask&XPRU_MSG)
	{
		sprintf(temp,"%-36s",updatestruct->xpru_msg);
		CurrentText.TopEdge = XferText7.TopEdge;
		CurrentText.LeftEdge = XferText7.LeftEdge+IntuiTextLength(&XferText7)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	if(updatestruct->xpru_updatemask&XPRU_ERRORMSG)
	{
		sprintf(temp,"%-32s",updatestruct->xpru_errormsg);
		CurrentText.TopEdge = XferText8.TopEdge;
		CurrentText.LeftEdge = XferText8.LeftEdge+IntuiTextLength(&XferText8)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	if(updatestruct->xpru_updatemask&XPRU_DATARATE)
	{
		sprintf(temp,"%-11ld",updatestruct->xpru_datarate);
		CurrentText.TopEdge = XferText9.TopEdge;
		CurrentText.LeftEdge = XferText9.LeftEdge+IntuiTextLength(&XferText9)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	if(updatestruct->xpru_updatemask&XPRU_BLOCKCHECK)
	{
		sprintf(temp,"%-11s",updatestruct->xpru_blockcheck);
		CurrentText.TopEdge = XferText10.TopEdge;
		CurrentText.LeftEdge = XferText10.LeftEdge+IntuiTextLength(&XferText10)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	if(updatestruct->xpru_updatemask&XPRU_EXPECTTIME)
	{
		sprintf(temp,"%-12s",updatestruct->xpru_expecttime);
		CurrentText.TopEdge = XferText11.TopEdge;
		CurrentText.LeftEdge = XferText11.LeftEdge+IntuiTextLength(&XferText11)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	if(updatestruct->xpru_updatemask&XPRU_ELAPSEDTIME)
	{
		sprintf(temp,"%-12s",updatestruct->xpru_elapsedtime);
		CurrentText.TopEdge = XferText12.TopEdge;
		CurrentText.LeftEdge = XferText12.LeftEdge+IntuiTextLength(&XferText12)+8;
		CurrentText.IText = temp;
		PrintIText(XferWindow->RPort,&CurrentText,0,0);
	}
	{
	}
	#if XPRDEBUG
	ScreenOut("Exiting xpr_update ",-1);
	#endif
	return 0L;
}

long xpr_gets(char *prompt, char *buffer)
{
	#if XPRDEBUG
	ScreenOut("Entering xpr_gets ",-1);
	#endif
	GetString(buffer,prompt,NULL,78,255);
	#if XPRDEBUG
	ScreenOut("Exiting xpr_gets ",-1);
	#endif
	return 0L;
}

long SetBit(long number, int BitNum)
{
	long power = 1L;
	int i = 1;
	while(i<BitNum)
	{
		power *= 2L;
		i++;
	}
	number |= power;
	return number;
}

BOOL TestBit(long number, int BitNum)
{
	int i = 1;
	long power = 1L;
	while(i<BitNum)
	{
		power *= 2L;
		i++;
	}
	if((power&number) == power)
		return TRUE;
	else
		return FALSE;
}

long xpr_setserial(long newstatus)
{
	int i;
	short bite = 0; // not to be confused with bit or byte!
	long number = 0L;

	#if XPRDEBUG
	ScreenOut("Entering xpr_setserial ",-1);
	#endif
	if(newstatus == -1) // Don't set anything, just return SP status
	{
		if(SerialIn->io_SerFlags&SERF_PARTY_ON)
			SetBit(number,1); // Parity on, set the bit
		if(SerialIn->io_SerFlags&SERF_PARTY_ODD)
			SetBit(number,2);	// Parity odd, set the bit
		if(SerialIn->io_SerFlags&SERF_7WIRE)
			SetBit(number,3);	// 7 wire handshake on, set the bit
		if(SerialIn->io_SerFlags&SERF_QUEUEDBRK)
			SetBit(number,4); // break commands queued, set the bit
		if(SerialIn->io_SerFlags&SERF_RAD_BOOGIE)
			SetBit(number,5); // rad boogie high speed, set the bit
		if(SerialIn->io_SerFlags&SERF_SHARED)
			SetBit(number,6); // SP shared, set the bit
		if(SerialIn->io_SerFlags&SERF_EOFMODE)
			SetBit(number,7); // EOF mode being used, set the bit
		if(SerialIn->io_SerFlags&SERF_XDISABLED)
			SetBit(number,8); // Xon/Xoff handshake disabled, set the bit
		if(SerialIn->io_ExtFlags&SEXTF_MSPON)
			SetBit(number,9); // Mark/Space parity being used, set the bit
		if(SerialIn->io_ExtFlags&SEXTF_MARK)
			SetBit(number,10); // Mark parity used, set the bit
		if(SerialIn->io_StopBits == 2)
			SetBit(number,11); // 2 stop bits, set the bit
		if(SerialIn->io_ReadLen == 7)
			SetBit(number,12); // 7 bit read length, set the bit
		if(SerialIn->io_WriteLen == 7)
			SetBit(number,13); // 7 bit write length, set the bit
		switch(SerialIn->io_Baud)
		{
			case 300:	SetBit(number,17); // 300 bps
							break;
			case 1200:	SetBit(number,18); // 1200 bps
							break;
			case 2400:	SetBit(number,17);
							SetBit(number,18); // 2400 bps
							break;
			case 4800:	SetBit(number,19); // 4800 bps
							break;
			case 9600:	SetBit(number,19);
							SetBit(number,17); // 9600 bps
							break;
			case 19200:	SetBit(number,19);
							SetBit(number,18); // 19200 bps
							break;
			case 38400:	SetBit(number,20); // 38400 bps
							break;
			case 57600:	SetBit(number,20);
							SetBit(number,17); // 57600 bps
							break;
			case 76800:	SetBit(number,20);
							SetBit(number,18); // 76800 bps
							break;
			case 115200:SetBit(number,20);
							SetBit(number,18);
							SetBit(number,19); // 115200 bps
							break;
		}
	}
	else
	{
		number = newstatus;
		if(TestBit(number,1))
			SerialIn->io_SerFlags |= SERF_PARTY_ON;
		if(TestBit(number,2))
			SerialIn->io_SerFlags |= SERF_PARTY_ODD;
		if(TestBit(number,3))
			SerialIn->io_SerFlags |= SERF_7WIRE;
		if(TestBit(number,4))
			SerialIn->io_SerFlags |= SERF_QUEUEDBRK;
		if(TestBit(number,5))
			SerialIn->io_SerFlags |= SERF_RAD_BOOGIE;
		if(TestBit(number,6))
			SerialIn->io_SerFlags |= SERF_SHARED;
		if(TestBit(number,7))
			SerialIn->io_SerFlags |= SERF_EOFMODE;
		if(TestBit(number,8))
			SerialIn->io_SerFlags |= SERF_XDISABLED;
		if(TestBit(number,9))
			SerialIn->io_ExtFlags |= SEXTF_MSPON;
		if(TestBit(number,10))
			SerialIn->io_ExtFlags |= SEXTF_MARK;
		SerialOut->io_ExtFlags = SerialIn->io_ExtFlags;
		if(TestBit(number,11))
			SerialIn->io_StopBits = 2;
		else
			SerialIn->io_StopBits = 1;
		SerialOut->io_StopBits = SerialIn->io_StopBits;
		if(TestBit(number,12))
			SerialIn->io_ReadLen = 7;
		else
			SerialIn->io_ReadLen = 8;
		SerialOut->io_ReadLen = SerialIn->io_ReadLen;
		if(TestBit(number,13))
			SerialIn->io_WriteLen = 7;
		else
			SerialIn->io_WriteLen = 8;
		SerialOut->io_WriteLen = SerialIn->io_WriteLen;
		// Extract byte 3 to determine baud rate (easier than other way)
		for(i=1;i<=8;i++)
			if(TestBit(number,i+16))
				SetBit(bite,i);
		switch(bite)
		{
			case 0:	SerialIn->io_Baud = 110;
						break;
			case 1:	SerialIn->io_Baud = 300;
						break;
			case 2:	SerialIn->io_Baud = 1200;
						break;
			case 3:	SerialIn->io_Baud = 2400;
						break;
			case 4:	SerialIn->io_Baud = 4800;
						break;
			case 5:	SerialIn->io_Baud = 9600;
						break;
			case 6:	SerialIn->io_Baud = 19200;
						break;
			case 8:	SerialIn->io_Baud = 38400;
						break;
			case 9:	SerialIn->io_Baud = 57600;
						break;
			case 10:	SerialIn->io_Baud = 76800;
						break;
			case 11:	SerialIn->io_Baud = 115200;
		}
		SerialOut->io_Baud = SerialIn->io_Baud;
		SerialIn->IOSer.io_Command = SDCMD_SETPARAMS;
		DoIO((struct IORequest *)SerialIn);
		if(SerialIn->IOSer.io_Error)
			number = -1L;
		else
		{
			SerialOut->IOSer.io_Command = SDCMD_SETPARAMS;
			DoIO((struct IORequest *)SerialOut);
		}
	}
	#if XPRDEBUG
	ScreenOut("Exiting xpr_setserial ",-1);
	#endif
	return number;
}

long xpr_fseek(void *fp, long offset, long origin)
{
	long number;
	#if XPRDEBUG
	ScreenOut("Entering xpr_fseek ",-1);
	#endif
	number =  fseek((FILE *)fp,offset,origin);
	#if XPRDEBUG
	ScreenOut("Exiting xpr_fseek ",-1);
	#endif
	return number;
}

long xpr_chkabort()
{
	struct IntuiMessage *IntuiMsg = NULL;
	long number = 0L;

	#if XPRDEBUG
	ScreenOut("Entering xpr_chkabort ",-1);
	#endif
	while(IntuiMsg = (struct IntuiMessage *)GetMsg(XferWindow->UserPort))
	{
		if(!IntuiMsg)
			number = 0L;
		else
		{
			if(IntuiMsg->Class == CLOSEWINDOW)
				number = -1L; // Abort this transfer
			ReplyMsg((struct Message *)IntuiMsg);
		}
	}
	#if XPRDEBUG
	ScreenOut("Exiting xpr_chkabort ",-1);
	#endif
	/* check for loss of carrier too
	SerialIn->IOSer.io_Command = SDCMD_QUERY;
	DoIO((struct IORequest *)SerialIn);
	if(TestBit(SerialIn->io_Status,6))
		number = -1; */
	return number;
}

long xpr_chkmisc()
{
	#if XPRDEBUG
	ScreenOut("Entering xpr_chkmisc ",-1);
	#endif
	#if XPRDEBUG
	ScreenOut("Exiting xpr_chkmisc ",-1);
	#endif
	return 0L;
}

long xpr_options(long n, struct xpr_option *opt[])
{
	int i;
	long def;
	struct GetLongStruct LongStruct;

	#if XPRDEBUG
	ScreenOut("Entering xpr_options ",-1);
	#endif
	for(i=0;i<=n;i++)
	{
		switch(opt[i]->xpro_type)
		{
			case XPRO_HEADER:		SimpleRequest(opt[i]->xpro_description);
										break;
			case XPRO_BOOLEAN:	if(TwoGadRequest(opt[i]->xpro_description))
											strcpy(opt[i]->xpro_value,"yes");
										else
											strcpy(opt[i]->xpro_value,"no");
										break;
			case XPRO_LONG:		LongStruct.titlebar = opt[i]->xpro_description;
										sscanf(opt[i]->xpro_value,"%ld",&def);
										LongStruct.defaultval = def;
										LongStruct.minlimit = 0L;
										LongStruct.maxlimit = 65535L;
										LongStruct.window = NULL;
										LongStruct.versionnumber = 0;
										LongStruct.flags = NULL;
										LongStruct.rfu2 = 0;
										LongStruct.result = 0;
										GetLong(&LongStruct);
										sprintf(opt[i]->xpro_value,"%ld",LongStruct.result);
										break;
			case XPRO_STRING:		GetString(opt[i]->xpro_value,opt[i]->xpro_description,NULL,78,opt[i]->xpro_length);
										break;
			case XPRO_COMMAND:	if(TwoGadRequest(opt[i]->xpro_description))
											strcpy(opt[i]->xpro_value,"yes");
										else
											strcpy(opt[i]->xpro_value,"no");
										return 0L;
										break;
			case XPRO_COMMPAR:	GetString(opt[i]->xpro_value,opt[i]->xpro_description,NULL,78,opt[i]->xpro_length);
										return 0L;
										break;
		}
	}
	#if XPRDEBUG
	ScreenOut("Exiting xpr_options ",-1);
	#endif
}

long xpr_unlink(char *filename)
{
	long number;
	#if XPRDEBUG
	ScreenOut("Entering xpr_unlink ",-1);
	#endif
	number = unlink(filename);
	#if XPRDEBUG
	ScreenOut("Exiting xpr_unlink ",-1);
	#endif
	return number;
}

long xpr_squery()
{
	#if XPRDEBUG
	ScreenOut("Entering xpr_squery ",-1);
	#endif
	SerialIn->IOSer.io_Command = SDCMD_QUERY;
	DoIO((struct IORequest *)SerialIn);
	#if XPRDEBUG
	ScreenOut("Exiting xpr_squery ",-1);
	#endif
	return (long)SerialIn->IOSer.io_Actual;
}

long xpr_getptr(long type)
{
	long number = 0L;
	#if XPRDEBUG
	ScreenOut("Entering xpr_getptr ",-1);
	#endif
	if(type == 1L)
		number = (long)Scr;
	#if XPRDEBUG
	ScreenOut("Exiting xpr_getptr ",-1);
	#endif
	return number;
}

long xpr_finfo(char *filename, long typeofinfo)
{
	struct FileInfoBlock *Info;
	BPTR mylock;
	long success;
	long number;

	#if XPRDEBUG
	ScreenOut("Entering xpr_finfo ",-1);
	#endif
	if(typeofinfo == 1L)
	{
		Info = (struct FileInfoBlock *)AllocMem(sizeof(struct FileInfoBlock),MEMF_CLEAR);
		if(!Info)
			return 0L;
		mylock = Lock(filename,ACCESS_READ);
		if(!mylock)
		{
			FreeMem(Info,sizeof(struct FileInfoBlock));
			return 0L;
		}
		success = Examine(mylock,Info);
		UnLock(mylock);
		if(!success)
		{
			FreeMem(Info,sizeof(struct FileInfoBlock));
			return 0L;
		}
		number = Info->fib_Size;
		FreeMem(Info,sizeof(struct FileInfoBlock));
	}
	if(typeofinfo == 2L)
		number = 1L; // For now, everything is binary :)
	#if XPRDEBUG
	ScreenOut("Exiting xpr_finfo ",-1);
	#endif
	return number;
}

void xpr_setup(struct XPR_IO *XprIO)
{
	XprIO->xpr_filename = NULL;
	XprIO->xpr_fopen    = axpr_fopen;
	XprIO->xpr_fclose   = axpr_fclose;
	XprIO->xpr_fread    = axpr_fread;
	XprIO->xpr_fwrite   = axpr_fwrite;
	XprIO->xpr_sread    = axpr_sread;
	XprIO->xpr_swrite   = axpr_swrite;
	XprIO->xpr_sflush   = axpr_sflush;
	XprIO->xpr_update   = axpr_update;
	XprIO->xpr_chkabort = axpr_chkabort;
	XprIO->xpr_chkmisc  = axpr_chkmisc;
	XprIO->xpr_gets     = axpr_gets;
	XprIO->xpr_setserial = axpr_setserial;
	XprIO->xpr_ffirst    = NULL;  // axpr_ffirst;
	XprIO->xpr_fnext     = NULL;  // axpr_fnext;
	XprIO->xpr_finfo     = axpr_finfo;
	XprIO->xpr_fseek     = axpr_fseek;
	XprIO->xpr_extension = 4;
	XprIO->xpr_data      = NULL;
	XprIO->xpr_options   = axpr_options;
	XprIO->xpr_unlink    = axpr_unlink;
	XprIO->xpr_squery    = axpr_squery;
	XprIO->xpr_getptr    = axpr_getptr;
}

long xpr_ffirst(char *buffer, char *pattern)
{
	if(!MyFileReq->ExtendedSelect)
		return 0L;
	strncpy(buffer,MyFileReq->ExtendedSelect->thefilename,MyFileReq->ExtendedSelect->NameLength);
	if(MyFileReq->ExtendedSelect->NextFile)
		return (long)MyFileReq->ExtendedSelect->NextFile;
	else
		return 1L;   // we'll look for this value in xpr_fnext()
}

long xpr_fnext(long oldstate, char *buffer, char *pattern)
{
	struct ESStructure *ptr;

	if(oldstate == 1L)
		return 0L;   // there was NO next file, ignore it all
	ptr = (struct ESStructure *)oldstate;
	strncpy(buffer,ptr->thefilename,ptr->NameLength);
	if(ptr->NextFile)
		return (long)ptr->NextFile;
	else
		return 1L;
}
